#compdef gitlabci

# AUTOMATICALLY GENERATED by `shtab`


_shtab_gitlabci_commands() {
  local _commands=(
    "autoscaler:"
    "completion:"
    "create:"
    "dashboard:"
    "destroy:"
    "hardening:"
    "jobs:"
    "monitoring:"
    "runner:"
    "ssh:"
    "status:"
  )
  _describe 'gitlabci commands' _commands
}

_shtab_gitlabci_autoscaler_commands() {
  local _commands=(
    "deploy:"
    "purge:"
    "status:"
  )
  _describe 'gitlabci autoscaler commands' _commands
}

_shtab_gitlabci_create_commands() {
  local _commands=(
    "aws:"
    "ssh:"
  )
  _describe 'gitlabci create commands' _commands
}

_shtab_gitlabci_dashboard_commands() {
  local _commands=(
    "deploy:"
    "get-token:"
    "purge:"
  )
  _describe 'gitlabci dashboard commands' _commands
}

_shtab_gitlabci_destroy_commands() {
  local _commands=(
    "aws:"
    "ssh:"
  )
  _describe 'gitlabci destroy commands' _commands
}

_shtab_gitlabci_hardening_commands() {
  local _commands=(
    "deploy:"
  )
  _describe 'gitlabci hardening commands' _commands
}

_shtab_gitlabci_jobs_commands() {
  local _commands=(
    "list:"
  )
  _describe 'gitlabci jobs commands' _commands
}

_shtab_gitlabci_monitoring_commands() {
  local _commands=(
    "deploy:"
    "get-admin-password:"
    "purge:"
  )
  _describe 'gitlabci monitoring commands' _commands
}

_shtab_gitlabci_runner_commands() {
  local _commands=(
    "deploy:"
    "list:"
    "purge:"
  )
  _describe 'gitlabci runner commands' _commands
}

_shtab_gitlabci_options=(
  "(- : *)"{-h,--help}"[show this help message and exit]"
)

_shtab_gitlabci_autoscaler_options=(
  "(- : *)"{-h,--help}"[show this help message and exit]"
)

_shtab_gitlabci_autoscaler_deploy_options=(
  "(- : *)"{-h,--help}"[show this help message and exit]"
)

_shtab_gitlabci_autoscaler_purge_options=(
  "(- : *)"{-h,--help}"[show this help message and exit]"
)

_shtab_gitlabci_autoscaler_status_options=(
  "(- : *)"{-h,--help}"[show this help message and exit]"
)

_shtab_gitlabci_completion_options=(
  "(- : *)"{-h,--help}"[show this help message and exit]"
  ":print shell completion script (default\: bash):(bash zsh tcsh)"
  ":print shell completion script:(bash zsh tcsh)"
)

_shtab_gitlabci_create_options=(
  "(- : *)"{-h,--help}"[show this help message and exit]"
)

_shtab_gitlabci_create_aws_options=(
  "(- : *)"{-h,--help}"[show this help message and exit]"
  "--kubernetes-version[specify K8s version]:kubernetes_version:"
  "--enable-metrics[deploy metrics server]"
  "--enable-autoscaler[deploy autoscaler addon]"
)

_shtab_gitlabci_create_ssh_options=(
  "(- : *)"{-h,--help}"[show this help message and exit]"
  "--kubernetes-version[specify K3s version]:kubernetes_version:"
)

_shtab_gitlabci_dashboard_options=(
  "(- : *)"{-h,--help}"[show this help message and exit]"
)

_shtab_gitlabci_dashboard_deploy_options=(
  "(- : *)"{-h,--help}"[show this help message and exit]"
)

_shtab_gitlabci_dashboard_get_token_options=(
  "(- : *)"{-h,--help}"[show this help message and exit]"
)

_shtab_gitlabci_dashboard_purge_options=(
  "(- : *)"{-h,--help}"[show this help message and exit]"
)

_shtab_gitlabci_destroy_options=(
  "(- : *)"{-h,--help}"[show this help message and exit]"
)

_shtab_gitlabci_destroy_aws_options=(
  "(- : *)"{-h,--help}"[show this help message and exit]"
)

_shtab_gitlabci_destroy_ssh_options=(
  "(- : *)"{-h,--help}"[show this help message and exit]"
)

_shtab_gitlabci_hardening_options=(
  "(- : *)"{-h,--help}"[show this help message and exit]"
)

_shtab_gitlabci_hardening_deploy_options=(
  "(- : *)"{-h,--help}"[show this help message and exit]"
  "--inventory[specify the ansible inventory]:inventory:"
  "--playbook[specify the playbook to harden the Kubernetes cluster]:playbook:"
  "--interactive[run in interactive mode, e.g. ask for ssh key password]"
)

_shtab_gitlabci_jobs_options=(
  "(- : *)"{-h,--help}"[show this help message and exit]"
)

_shtab_gitlabci_jobs_list_options=(
  "(- : *)"{-h,--help}"[show this help message and exit]"
  "--namespace[kubernetes namespace to use]:namespace:"
)

_shtab_gitlabci_monitoring_options=(
  "(- : *)"{-h,--help}"[show this help message and exit]"
)

_shtab_gitlabci_monitoring_deploy_options=(
  "(- : *)"{-h,--help}"[show this help message and exit]"
  "--namespace[deploy in the given namespace]:namespace:"
)

_shtab_gitlabci_monitoring_get_admin_password_options=(
  "(- : *)"{-h,--help}"[show this help message and exit]"
  "--namespace[monitoring namespace]:namespace:"
)

_shtab_gitlabci_monitoring_purge_options=(
  "(- : *)"{-h,--help}"[show this help message and exit]"
  "--namespace[monitoring namespace]:namespace:"
)

_shtab_gitlabci_runner_options=(
  "(- : *)"{-h,--help}"[show this help message and exit]"
)

_shtab_gitlabci_runner_deploy_options=(
  "(- : *)"{-h,--help}"[show this help message and exit]"
  "--namespace[deploy in the given namespace]:namespace:"
  "--token[Gitlab runner token]:token:"
  "--config[configuration file for the Gitlab runner]:config:_files"
  ":name:"
)

_shtab_gitlabci_runner_list_options=(
  "(- : *)"{-h,--help}"[show this help message and exit]"
  "--namespace[use the given namespace]:namespace:"
)

_shtab_gitlabci_runner_purge_options=(
  "(- : *)"{-h,--help}"[show this help message and exit]"
  "--namespace[use the given namespace]:namespace:"
  "(*):names:"
)

_shtab_gitlabci_ssh_options=(
  "(- : *)"{-h,--help}"[show this help message and exit]"
)

_shtab_gitlabci_status_options=(
  "(- : *)"{-h,--help}"[show this help message and exit]"
  "--namespace[use the given namespace (default\: gitlab)]:namespace:"
)


_shtab_gitlabci() {
  local context state line curcontext="$curcontext" one_or_more='(-)*' remainder='(*)'

  if ((${_shtab_gitlabci_options[(I)${(q)one_or_more}*]} + ${_shtab_gitlabci_options[(I)${(q)remainder}*]} == 0)); then  # noqa: E501
    _shtab_gitlabci_options+=(': :_shtab_gitlabci_commands' '*::: :->gitlabci')
  fi
  _arguments -C -s $_shtab_gitlabci_options

  case $state in
    gitlabci)
      words=($line[1] "${words[@]}")
      (( CURRENT += 1 ))
      curcontext="${curcontext%:*:*}:_shtab_gitlabci-$line[1]:"
      case $line[1] in
        autoscaler) _shtab_gitlabci_autoscaler ;;
        completion) _arguments -C -s $_shtab_gitlabci_completion_options ;;
        create) _shtab_gitlabci_create ;;
        dashboard) _shtab_gitlabci_dashboard ;;
        destroy) _shtab_gitlabci_destroy ;;
        hardening) _shtab_gitlabci_hardening ;;
        jobs) _shtab_gitlabci_jobs ;;
        monitoring) _shtab_gitlabci_monitoring ;;
        runner) _shtab_gitlabci_runner ;;
        ssh) _arguments -C -s $_shtab_gitlabci_ssh_options ;;
        status) _arguments -C -s $_shtab_gitlabci_status_options ;;
      esac
  esac
}

_shtab_gitlabci_autoscaler() {
  local context state line curcontext="$curcontext" one_or_more='(-)*' remainder='(*)'

  if ((${_shtab_gitlabci_autoscaler_options[(I)${(q)one_or_more}*]} + ${_shtab_gitlabci_autoscaler_options[(I)${(q)remainder}*]} == 0)); then  # noqa: E501
    _shtab_gitlabci_autoscaler_options+=(': :_shtab_gitlabci_autoscaler_commands' '*::: :->autoscaler')
  fi
  _arguments -C -s $_shtab_gitlabci_autoscaler_options

  case $state in
    autoscaler)
      words=($line[1] "${words[@]}")
      (( CURRENT += 1 ))
      curcontext="${curcontext%:*:*}:_shtab_gitlabci_autoscaler-$line[1]:"
      case $line[1] in
        deploy) _arguments -C -s $_shtab_gitlabci_autoscaler_deploy_options ;;
        purge) _arguments -C -s $_shtab_gitlabci_autoscaler_purge_options ;;
        status) _arguments -C -s $_shtab_gitlabci_autoscaler_status_options ;;
      esac
  esac
}

_shtab_gitlabci_create() {
  local context state line curcontext="$curcontext" one_or_more='(-)*' remainder='(*)'

  if ((${_shtab_gitlabci_create_options[(I)${(q)one_or_more}*]} + ${_shtab_gitlabci_create_options[(I)${(q)remainder}*]} == 0)); then  # noqa: E501
    _shtab_gitlabci_create_options+=(': :_shtab_gitlabci_create_commands' '*::: :->create')
  fi
  _arguments -C -s $_shtab_gitlabci_create_options

  case $state in
    create)
      words=($line[1] "${words[@]}")
      (( CURRENT += 1 ))
      curcontext="${curcontext%:*:*}:_shtab_gitlabci_create-$line[1]:"
      case $line[1] in
        aws) _arguments -C -s $_shtab_gitlabci_create_aws_options ;;
        ssh) _arguments -C -s $_shtab_gitlabci_create_ssh_options ;;
      esac
  esac
}

_shtab_gitlabci_dashboard() {
  local context state line curcontext="$curcontext" one_or_more='(-)*' remainder='(*)'

  if ((${_shtab_gitlabci_dashboard_options[(I)${(q)one_or_more}*]} + ${_shtab_gitlabci_dashboard_options[(I)${(q)remainder}*]} == 0)); then  # noqa: E501
    _shtab_gitlabci_dashboard_options+=(': :_shtab_gitlabci_dashboard_commands' '*::: :->dashboard')
  fi
  _arguments -C -s $_shtab_gitlabci_dashboard_options

  case $state in
    dashboard)
      words=($line[1] "${words[@]}")
      (( CURRENT += 1 ))
      curcontext="${curcontext%:*:*}:_shtab_gitlabci_dashboard-$line[1]:"
      case $line[1] in
        deploy) _arguments -C -s $_shtab_gitlabci_dashboard_deploy_options ;;
        get-token) _arguments -C -s $_shtab_gitlabci_dashboard_get_token_options ;;
        purge) _arguments -C -s $_shtab_gitlabci_dashboard_purge_options ;;
      esac
  esac
}

_shtab_gitlabci_destroy() {
  local context state line curcontext="$curcontext" one_or_more='(-)*' remainder='(*)'

  if ((${_shtab_gitlabci_destroy_options[(I)${(q)one_or_more}*]} + ${_shtab_gitlabci_destroy_options[(I)${(q)remainder}*]} == 0)); then  # noqa: E501
    _shtab_gitlabci_destroy_options+=(': :_shtab_gitlabci_destroy_commands' '*::: :->destroy')
  fi
  _arguments -C -s $_shtab_gitlabci_destroy_options

  case $state in
    destroy)
      words=($line[1] "${words[@]}")
      (( CURRENT += 1 ))
      curcontext="${curcontext%:*:*}:_shtab_gitlabci_destroy-$line[1]:"
      case $line[1] in
        aws) _arguments -C -s $_shtab_gitlabci_destroy_aws_options ;;
        ssh) _arguments -C -s $_shtab_gitlabci_destroy_ssh_options ;;
      esac
  esac
}

_shtab_gitlabci_hardening() {
  local context state line curcontext="$curcontext" one_or_more='(-)*' remainder='(*)'

  if ((${_shtab_gitlabci_hardening_options[(I)${(q)one_or_more}*]} + ${_shtab_gitlabci_hardening_options[(I)${(q)remainder}*]} == 0)); then  # noqa: E501
    _shtab_gitlabci_hardening_options+=(': :_shtab_gitlabci_hardening_commands' '*::: :->hardening')
  fi
  _arguments -C -s $_shtab_gitlabci_hardening_options

  case $state in
    hardening)
      words=($line[1] "${words[@]}")
      (( CURRENT += 1 ))
      curcontext="${curcontext%:*:*}:_shtab_gitlabci_hardening-$line[1]:"
      case $line[1] in
        deploy) _arguments -C -s $_shtab_gitlabci_hardening_deploy_options ;;
      esac
  esac
}

_shtab_gitlabci_jobs() {
  local context state line curcontext="$curcontext" one_or_more='(-)*' remainder='(*)'

  if ((${_shtab_gitlabci_jobs_options[(I)${(q)one_or_more}*]} + ${_shtab_gitlabci_jobs_options[(I)${(q)remainder}*]} == 0)); then  # noqa: E501
    _shtab_gitlabci_jobs_options+=(': :_shtab_gitlabci_jobs_commands' '*::: :->jobs')
  fi
  _arguments -C -s $_shtab_gitlabci_jobs_options

  case $state in
    jobs)
      words=($line[1] "${words[@]}")
      (( CURRENT += 1 ))
      curcontext="${curcontext%:*:*}:_shtab_gitlabci_jobs-$line[1]:"
      case $line[1] in
        list) _arguments -C -s $_shtab_gitlabci_jobs_list_options ;;
      esac
  esac
}

_shtab_gitlabci_monitoring() {
  local context state line curcontext="$curcontext" one_or_more='(-)*' remainder='(*)'

  if ((${_shtab_gitlabci_monitoring_options[(I)${(q)one_or_more}*]} + ${_shtab_gitlabci_monitoring_options[(I)${(q)remainder}*]} == 0)); then  # noqa: E501
    _shtab_gitlabci_monitoring_options+=(': :_shtab_gitlabci_monitoring_commands' '*::: :->monitoring')
  fi
  _arguments -C -s $_shtab_gitlabci_monitoring_options

  case $state in
    monitoring)
      words=($line[1] "${words[@]}")
      (( CURRENT += 1 ))
      curcontext="${curcontext%:*:*}:_shtab_gitlabci_monitoring-$line[1]:"
      case $line[1] in
        deploy) _arguments -C -s $_shtab_gitlabci_monitoring_deploy_options ;;
        get-admin-password) _arguments -C -s $_shtab_gitlabci_monitoring_get_admin_password_options ;;
        purge) _arguments -C -s $_shtab_gitlabci_monitoring_purge_options ;;
      esac
  esac
}

_shtab_gitlabci_runner() {
  local context state line curcontext="$curcontext" one_or_more='(-)*' remainder='(*)'

  if ((${_shtab_gitlabci_runner_options[(I)${(q)one_or_more}*]} + ${_shtab_gitlabci_runner_options[(I)${(q)remainder}*]} == 0)); then  # noqa: E501
    _shtab_gitlabci_runner_options+=(': :_shtab_gitlabci_runner_commands' '*::: :->runner')
  fi
  _arguments -C -s $_shtab_gitlabci_runner_options

  case $state in
    runner)
      words=($line[1] "${words[@]}")
      (( CURRENT += 1 ))
      curcontext="${curcontext%:*:*}:_shtab_gitlabci_runner-$line[1]:"
      case $line[1] in
        deploy) _arguments -C -s $_shtab_gitlabci_runner_deploy_options ;;
        list) _arguments -C -s $_shtab_gitlabci_runner_list_options ;;
        purge) _arguments -C -s $_shtab_gitlabci_runner_purge_options ;;
      esac
  esac
}



typeset -A opt_args

if [[ $zsh_eval_context[-1] == eval ]]; then
  # eval/source/. command, register function for later
  compdef _shtab_gitlabci -N gitlabci
else
  # autoload from fpath, call function directly
  _shtab_gitlabci "$@"
fi

